/*--------------------------------------------------------------------------------------*/
/*	LZW_GIFfR[_[{ t@C	Ver 1.00									*/
/*	for VisualStudio6.0 only															*/
/*	ۂ̓WJsADIBƂĕԋp܂B										*/
/*	Copyright (C) 2000 DJUchi [H.Uchida]												*/
/*--------------------------------------------------------------------------------------*/
#include "GIFDecode.h"


/*--------------------------------------------------------------------------------------*/
/*	GifDecode()																			*/
/*	GIF摜iŏ̈ꖇ̂݁jWJB												*/
/*	͂GIFf[^Ao͂DIBB														*/
/*	ł͎ɃfR[h̑Os܂B											*/
/*--------------------------------------------------------------------------------------*/
void GifDecode(BYTE *rgb, BYTE *gif, DWORD width, DWORD height,
			   DWORD align, DWORD inter ,WORD color, DWORD size)
{
	WORD lzw[8192];							//kf[^i[pzie[uł͂ȂIj
	DWORD code = 0;							//R[h

	//GIFf[^͗p\̏
	GIFDECODESTATUS gs;
	gs.code_size	= gif[0];				//R[hTCY擾
	gs.bit_size		= gs.code_size + 1;		//CBLiR[hTCY+1j
	gs.clear_code	= 1 << gs.code_size;	//NAR[hݒi2^R[hTCYj
	gs.end_code		= gs.clear_code + 1;	//GhR[hݒi2^R[hTCY+1j
	gs.entry		= gs.end_code + 1;		//Ggi2^R[hTCY+2j
	gs.bit_pt		= 8;					//rbg|C^(8bit=1byte)
	gs.next_block	= 1;					//ubNʒui擪ubNj
	gs.data_size	= size;					//GIFf[^TCY擾

	//DIBf[^ݗp\̏
	RGBDECODESTATUS rs;
	rs.gs			= &gs;					//GIFDECODESTATUS\̎QƗp|C^擾
	rs.rgb_pt		= 0;					//WJf[^݈ʒu
	rs.rgb_offset	= (height - 1) * align;	//݈ʒuItZbg
	rs.rgb_width	= width;				//DIBpixel擾
	rs.rgb_height	= height;				//DIBcpixel擾
	rs.rgb_align	= align;				//DIBACgl擾
	rs.rgb_color	= color;				//DIBJ[rbgl擾
	rs.rgb_line		= 0;					//WJf[^݃C
	rs.inter_offset	= 8;					//C^[XItZbg
	rs.inter_flag	= inter;				//C^[XtO擾

	int x = 0;								//WJ񐔏
	int y = 0;								//WJJnʒu

	//GhR[h܂łЂ烋[v
	while ((code = GetCode(gif,&gs)) != gs.end_code) {
		//NAR[hꂽꍇ
		if (code == gs.clear_code) {
			//GgCBL
			gs.entry = gs.end_code + 1;
			gs.bit_size = gs.code_size + 1;
			//WJ֐R[B
			lzw_decode(rgb, lzw, &rs, x, y);
			x = 0;
			y = 0;
		} else {
			//WORDTCYzɎ擾R[h𗭂ߍށB
			//͓WJƂ~ɍsׂłAe[uƂ͈قȂ܂B
			//zɗߍ܂Ɏ擾R[h𒼂ɓWJ邱Ƃo܂A
			//xIɖ肪ׁA̕@̗pĂ܂B
			lzw[x++] = (WORD)code;
			//܂łNAR[hȂƔz񂪈邽߁A
			//R[h8192܂_œWJƂsB
			//񈳏kGIF΍􂩁H
			if (x == 8192) {
				lzw_decode(rgb, lzw, &rs, x, y);
				x = 4096;
				y = 4096;
			}
			if (gs.entry < 4095) gs.entry++;
		}
	}
	//zɎcĂ镄R[hWJB
	lzw_decode(rgb, lzw, &rs, x, y);

	return;
}


/*--------------------------------------------------------------------------------------*/
/*	GetCode()																			*/
/*	σrbg͊֐B																*/
/*	R[hoāArbgʒuCNgB					*/
/*--------------------------------------------------------------------------------------*/
DWORD GetCode(BYTE *gif, GIFDECODESTATUS *gs)
{
	DWORD code = 0;					//R[h
	DWORD pt = gs->bit_pt >> 3;		//ǂݍ݈ʒuioCgPʁj擾

	//TCYI[o[t[̏ꍇAIɃGhR[hԂijt@C΍j
	if (pt + 2 > gs->data_size) return gs->end_code;

	//R[h擾
	int i = 0;	//ǂݍ݃oCg
	while ((gs->bit_pt + gs->bit_size - 1) >> 3 >= pt) {
		//ǂݍݒɃubNIꍇ
		if (pt == gs->next_block) {
			gs->next_block += gif[pt++] + 1;	//ubNʒuXV
			gs->bit_pt += 8;					//rbg|C^PoCgZ
		}
		code += gif[pt++] << i;					//R[h擾
		i += 8;
	}

	//ꂽR[h̗]ȃrbg؂Ƃ΂Bi}XLOj
	code = (code >> (gs->bit_pt & 0x07)) & ((1 << gs->bit_size) - 1);
	//rbg|C^XV
	gs->bit_pt += gs->bit_size;
	//CBLCNgKv邩ǂmFB
	if (gs->entry > (DWORD)((1 << gs->bit_size) - 1)) gs->bit_size++;

	return code;
}


/*--------------------------------------------------------------------------------------*/
/*	lzw_decode()																		*/
/*	LZW_WJ֐iC[vj													*/
/*	WORDTCY̔zɊi[ꂽR[hfR[h܂B						*/
/*--------------------------------------------------------------------------------------*/
void lzw_decode(BYTE *rgb, WORD *lzw, RGBDECODESTATUS *rs, int x, int y)
{
	//PɃ[v񂵂ēWJ֐Ăł邾B
	for (int i=y; i<x; i++) {
		lzw_string(rgb, lzw, rs, i);
	}
}


/*--------------------------------------------------------------------------------------*/
/*	lzw_string()																		*/
/*	LZW_WJ֐iRAj															*/
/*	LZW_̊jB																	*/
/*	w肳ꂽR[hɑ΂WJf[^Ԃ܂B								*/
/*--------------------------------------------------------------------------------------*/
void lzw_string(BYTE *rgb, WORD *lzw, RGBDECODESTATUS *rs, int x)
{
	//z񂩂畄R[ho܂B
	WORD code = lzw[x];

	//R[hhFh菬ꍇ
	if (code < rs->gs->clear_code) {
		//R[ĥ܂DIBɏށB
		rgb_write(rgb, rs, code);

	//R[hm̂̂łꍇ
	} else if (code > rs->gs->end_code + x) {
		//O̓WJf[^
		lzw_string(rgb, lzw, rs, --x);
		//O̓WJf[^̐擪
		lzw_char(rgb, lzw, rs, --x);

	//R[hhF+1h傫ꍇ
	//Ȃ݂ɁÅ֐ɓĂR[hɃGhR[hNAR[h
	//΂Ɍ܂̂ŁȀꍇ͍̏lĂ܂B
	} else {
		//iR[h-F+1j̓WJf[^
		lzw_string(rgb, lzw, rs, code - rs->gs->end_code - 1);
		//iR[h-F+2j̓WJf[^̐擪
		lzw_char(rgb, lzw, rs, code - rs->gs->end_code);
	}
}


/*--------------------------------------------------------------------------------------*/
/*	lzw_char()																			*/
/*	LZW_WJ֐iTuj															*/
/*	LZW_̊jB																	*/
/*	w肳ꂽR[hɑ΂WJf[^̐擪PԂ܂B					*/
/*--------------------------------------------------------------------------------------*/
void lzw_char(BYTE *rgb, WORD *lzw, RGBDECODESTATUS *rs, int x)
{
	//z񂩂畄R[ho܂B
	WORD code = lzw[x];

	//R[hhFh菬ꍇ
	if (code < rs->gs->clear_code) {
		//R[ĥ܂DIBɏށB
		rgb_write(rgb, rs, code);

	//R[hm̂̂łꍇ
	} else if (code > rs->gs->end_code + x) {
		//O̓WJf[^̐擪
		lzw_char(rgb, lzw, rs, --x);

	//R[hhF+1h傫ꍇ
	} else {
		//iR[h-F+1j̓WJf[^̐擪
		lzw_char(rgb, lzw, rs, code - rs->gs->end_code - 1);
	}
}


/*--------------------------------------------------------------------------------------*/
/*	rgb_write()																			*/
/*	DIB摜f[^݊֐B															*/
/*	WJꂽ摜f[^DIBƂď݂܂B										*/
/*--------------------------------------------------------------------------------------*/
void rgb_write(BYTE *rgb, RGBDECODESTATUS *rs, WORD code)
{
	//DIBɉ摜f[^݂܂B
	//mN16F̏ꍇ̓rbgPʂł݂̏ɂȂׁA}XLOs܂B
	DWORD i, j;
	if (rs->rgb_color == 1) {			//mN摜̏ꍇ
		i = rs->rgb_offset + (rs->rgb_pt >> 3);
		j = 7 - (rs->rgb_pt & 0x07);
		rgb[i] = (rgb[i] & ~(1 << j)) | (code << j);
	} else if (rs->rgb_color == 4) {	//16F摜̏ꍇ
		i = rs->rgb_offset + (rs->rgb_pt >> 1);
		j = (rs->rgb_pt & 0x01) << 2;
		rgb[i] = (rgb[i] & (0x0F << j)) | (code << (4 - j));
	} else {							//256F̏ꍇ
		rgb[rs->rgb_offset + rs->rgb_pt] = (BYTE)code;
	}

	//݈ʒuCNg
	rs->rgb_pt++;
	//݈ʒuC̏I[ɒBꍇ
	if (rs->rgb_pt == rs->rgb_width) {
		if (rs->inter_flag) {	//C^[XGIF̏ꍇ
			//C^[XCʉ[ɒBꍇ
			if (rs->rgb_line + rs->inter_offset >= rs->rgb_height){
				if ((rs->rgb_line & 0x07) == 0) {
					rs->rgb_offset = (rs->rgb_height - 5) * rs->rgb_align;
					rs->rgb_line = 4;
				} else if (rs->inter_offset == 8) {
					rs->rgb_offset = (rs->rgb_height - 3) * rs->rgb_align;
					rs->rgb_line = 2;
					rs->inter_offset = 4;
				} else if (rs->inter_offset == 4) {
					rs->rgb_offset = (rs->rgb_height - 2) * rs->rgb_align;
					rs->rgb_line = 1;
					rs->inter_offset = 2;
				}
			} else {
				rs->rgb_offset -= rs->rgb_align * rs->inter_offset;
				rs->rgb_line += rs->inter_offset;
			}
		} else {				//jAGIF̏ꍇ
			rs->rgb_offset -= rs->rgb_align;
		}
		rs->rgb_pt = 0;
	}
}
